#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private BD.ICTMarketStructure[] cacheICTMarketStructure;
		private BD.ZigZag2[] cacheZigZag2;

		
		public BD.ICTMarketStructure ICTMarketStructure()
		{
			return ICTMarketStructure(Input);
		}

		public BD.ZigZag2 ZigZag2(bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			return ZigZag2(Input, useHighLow, percentageReversal, absoluteReversal, atrLength, atrReversal);
		}


		
		public BD.ICTMarketStructure ICTMarketStructure(ISeries<double> input)
		{
			if (cacheICTMarketStructure != null)
				for (int idx = 0; idx < cacheICTMarketStructure.Length; idx++)
					if ( cacheICTMarketStructure[idx].EqualsInput(input))
						return cacheICTMarketStructure[idx];
			return CacheIndicator<BD.ICTMarketStructure>(new BD.ICTMarketStructure(), input, ref cacheICTMarketStructure);
		}

		public BD.ZigZag2 ZigZag2(ISeries<double> input, bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			if (cacheZigZag2 != null)
				for (int idx = 0; idx < cacheZigZag2.Length; idx++)
					if (cacheZigZag2[idx].UseHighLow == useHighLow && cacheZigZag2[idx].PercentageReversal == percentageReversal && cacheZigZag2[idx].AbsoluteReversal == absoluteReversal && cacheZigZag2[idx].AtrLength == atrLength && cacheZigZag2[idx].AtrReversal == atrReversal && cacheZigZag2[idx].EqualsInput(input))
						return cacheZigZag2[idx];
			return CacheIndicator<BD.ZigZag2>(new BD.ZigZag2(){ UseHighLow = useHighLow, PercentageReversal = percentageReversal, AbsoluteReversal = absoluteReversal, AtrLength = atrLength, AtrReversal = atrReversal }, input, ref cacheZigZag2);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.BD.ICTMarketStructure ICTMarketStructure()
		{
			return indicator.ICTMarketStructure(Input);
		}

		public Indicators.BD.ZigZag2 ZigZag2(bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			return indicator.ZigZag2(Input, useHighLow, percentageReversal, absoluteReversal, atrLength, atrReversal);
		}


		
		public Indicators.BD.ICTMarketStructure ICTMarketStructure(ISeries<double> input )
		{
			return indicator.ICTMarketStructure(input);
		}

		public Indicators.BD.ZigZag2 ZigZag2(ISeries<double> input , bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			return indicator.ZigZag2(input, useHighLow, percentageReversal, absoluteReversal, atrLength, atrReversal);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.BD.ICTMarketStructure ICTMarketStructure()
		{
			return indicator.ICTMarketStructure(Input);
		}

		public Indicators.BD.ZigZag2 ZigZag2(bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			return indicator.ZigZag2(Input, useHighLow, percentageReversal, absoluteReversal, atrLength, atrReversal);
		}


		
		public Indicators.BD.ICTMarketStructure ICTMarketStructure(ISeries<double> input )
		{
			return indicator.ICTMarketStructure(input);
		}

		public Indicators.BD.ZigZag2 ZigZag2(ISeries<double> input , bool useHighLow, double percentageReversal, double absoluteReversal, int atrLength, double atrReversal)
		{
			return indicator.ZigZag2(input, useHighLow, percentageReversal, absoluteReversal, atrLength, atrReversal);
		}

	}
}

#endregion
